<script>

import { mapActions, mapState } from 'pinia'
import { ConcernementsStore } from '@stores/concernements'
import { UserStore } from '@/stores/user'
import { CommonStore } from '@/stores/common'

import { print } from 'graphql/language/printer'
import gql from 'graphql-tag'
import GQL from '@api/graphql-axios'
import EntiteFields from '@api/gql/entite.fragment.gql'

// import SvgIcon from '@jamescoyle/vue-icon';
// import { mdiHeadphones } from '@mdi/js';

import TerrainDeVie from '@components/contents/TerrainDeVie.vue';
import PuissanceAgir from '@components/contents/PuissanceAgir.vue';
import Doleancer from '@components/contents/Doleancer.vue';

export default {
  props: ['id', 'eid'],
  data(){
    return {
      entite: null,
      opened_besoin_id: null
    }
  },
  computed: {
    ...mapState(UserStore,['isloggedin']),
    ...mapState(ConcernementsStore,['map_mode']),
    ...mapState(ConcernementsStore,['opened_concernement']),
    // ...mapState(ConcernementsStore,['opened_entity_id']),
    ...mapState(ConcernementsStore,['concernements_loaded']),
    ...mapState(ConcernementsStore,['ct_concernement']),
    ...mapState(ConcernementsStore,['ct_entite']),
    ...mapState(ConcernementsStore,['ct_cercle_politique']),
    ...mapState(ConcernementsStore,['p_groupes_interets']),
    ...mapState(ConcernementsStore,['p_reception_et_traitement']),
    ...mapState(ConcernementsStore,['p_mise_en_oeuvre_decision']),
    ...mapState(ConcernementsStore,['p_reception_application_decision']),
    ...mapState(CommonStore,['hover_elmt'])
  },
  created () {
    console.log(`Concernement view created, id: ${this.id}, eid: ${this.eid}, opened_concernement:${this.opened_concernement}`);
    
    // when we arrived directly to the url, load the entite
    // this.eid provided by route params
    if (!this.entity && this.eid) {
      this.openEntity();
    }
  },
  watch: {
    concernements_loaded: {
      handler (n, o){
        console.log(`watch concernements_loaded n: ${n}, opened_concernement:${this.opened_concernement}, id:${this.id}`);
        // when we arrived directly to the url then all concernement are loaded: do open the concernement
        if (!this.opened_concernement) {
          this.openCloseConcernements(this.id)
        }
   
      },
      deep: true
    },
    eid: {
      handler (n, o){
        if(n){
          this.openEntity()
        }else{
          this.entite = false;
          this.setOpenedEntityId(null);
        }
      },
      deep: true
    },
  },
  methods: {
    ...mapActions(ConcernementsStore,['openCloseConcernements']),
    ...mapActions(ConcernementsStore,['setOpenedEntityId']),
    ...mapActions(ConcernementsStore,['setMapMode']),
    openEntity(){
      this.setOpenedEntityId(parseInt(this.eid))
      this.loadEntite()
    },
    loadEntite(){
      const ast = gql`{
        entite (id: ${this.eid}) {
          ...EntiteFields
        }
      }
      ${EntiteFields}
      `
      console.log('ast', ast);
      GQL.post('', { query: print(ast) })
        .then(({data: { data: { entite }}}) => {
          console.log('load entite loaded', entite)
          this.entite = entite
        })
        .catch(error => {
          console.warn('Issue with load entite', error)
        })
    },
    onClickBesoin(id){
      console.log("onClickBesoin", id);
      this.opened_besoin_id = id === this.opened_besoin_id ? null : id;
    },
    besoinClass(id){
      return this.opened_besoin_id === id ? "opened" : "";
    }
  },
  components: {
    TerrainDeVie,
    PuissanceAgir,
    Doleancer
  }
}

</script>

<template>
  <section v-if="opened_concernement" class="concernement">
    <TerrainDeVie v-if="map_mode === 'terraindevie'" :id="id" :eid="eid" :entite="entite"/>
    <PuissanceAgir v-if="map_mode === 'puissancedagir'" :id="id"/>
    <Doleancer v-if="map_mode === 'doleancer'" :id="id"/>
    
  </section>
</template>

<style lang="scss" scoped>

</style>
